Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- File List
- File Members

gost_28147.h
Go to the documentation of this file.
1 /*
2 * GOST 28147-89
3 * (C) 1999-2009 Jack Lloyd
4 *
5 * Botan is released under the Simplified BSD License (see license.txt)
6 */
7
8 #ifndef BOTAN_GOST_28147_89_H__
9 #define BOTAN_GOST_28147_89_H__
10
11 #include <botan/block_cipher.h>
12
13 namespace Botan {
14
15 /**
16 * The GOST 28147-89 block cipher uses a set of 4 bit Sboxes, however
17 * the standard does not actually define these Sboxes; they are
18 * considered a local configuration issue. Several different sets are
19 * used.
20 */
21 class BOTAN_DLL GOST_28147_89_Params
22 {
23 public:
24 /**
25 * @param row the row
26 * @param col the column
27 * @return sbox entry at this row/column
28 */
29 uint8_t sbox_entry(size_t row, size_t col) const;
30
31 /**
32 * @return name of this parameter set
33 */
34 std::string param_name() const { return m_name; }
35
36 /**
37 * Default GOST parameters are the ones given in GOST R 34.11 for
38 * testing purposes; these sboxes are also used by Crypto++, and,
39 * at least according to Wikipedia, the Central Bank of Russian
40 * Federation
41 * @param name of the parameter set
42 */
43 GOST_28147_89_Params(const std::string& name = "R3411_94_TestParam");
44 private:
45 const uint8_t* m_sboxes;
46 std::string m_name;
47 };
48
49 /**
50 * GOST 28147-89
51 */
52 class BOTAN_DLL GOST_28147_89 final : public Block_Cipher_Fixed_Params<8, 32>
53 {
54 public:
55 void encrypt_n(const uint8_t in[], uint8_t out[], size_t blocks) const override;
56 void decrypt_n(const uint8_t in[], uint8_t out[], size_t blocks) const override;
57
58 void clear() override;
59
60 std::string name() const override;
61 BlockCipher* clone() const override { return new GOST_28147_89(m_SBOX); }
62
63 /**
64 * @param params the sbox parameters to use
65 */
66 explicit GOST_28147_89(const GOST_28147_89_Params& params);
67 private:
68 explicit GOST_28147_89(const std::vector<uint32_t>& other_SBOX) :
69 m_SBOX(other_SBOX), m_EK(8) {}
70
71 void key_schedule(const uint8_t[], size_t) override;
72
73 /*
74 * The sbox is not secret, this is just a larger expansion of it
75 * which we generate at runtime for faster execution
76 */
77 std::vector<uint32_t> m_SBOX;
78
79 secure_vector<uint32_t> m_EK;
80 };
81
82 }
83
84 #endif
m_name
std::string m_name
Definition: openssl_hash.cpp:69
Botan::GOST_28147_89_Params
Definition: gost_28147.h:21
Botan::GOST_28147_89
Definition: gost_28147.h:52
Botan::GOST_28147_89_Params::param_name
std::string param_name() const
Definition: gost_28147.h:34
Botan
Definition: alg_id.cpp:13
Botan::Block_Cipher_Fixed_Params
Definition: block_cipher.h:183
Botan::GOST_28147_89::clone
BlockCipher * clone() const override
Definition: gost_28147.h:61
Botan::BlockCipher
Definition: block_cipher.h:19